<?php

// -------------------------------------------------------------------------- \\
// Post tree system manager - provides interfaces for comments and forums     \\
// -------------------------------------------------------------------------- \\

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

if (defined('QF_PSTTREE_LOADED'))
    die('Scripting error');

define('QF_PSTTREE_LOADED', true);


define('QF_PSTTREE_CACHE_PREFIX', 'POSTTREE.');

class QF2_PostTree
{
    var $ptrees = Array();

    function QF2_PostTree()
    {

    }

    function Render_Tree($tid)
    {
        global $QF, $FOX;

        if (!is_numeric($tid))
            return false;

        $tid = (int) $tid;
        if (!isset($this->ptrees[$tid]) && !$this->_Load_Tree($tid))
            return false;

        $data = $this->ptrees[$tid];
        $QF->Run_Module('VIS');
        $QF->VIS->Load_Templates('posttree');
        $root_node = $QF->VIS->Create_Node('FOX_POSTTREE_OUTER');

        $par_nodes = Array(1 => $root_node);
        foreach($data['ptree'] as $pdata)
        {
            $cur_node = $QF->VIS->Add_Node('FOX_POSTTREE_POST', 'SUB_POSTS', $par_nodes[$pdata['t_level']], Array(
                'PTEXT' => $pdata['post_id'],
                ));
            $par_nodes[$pdata['t_level']+1] = $cur_node;
        }

        return $root_node;
    }

    function Create_Tree($class, $data, $params)
    {
        global $QF, $FOX;

        return $tid;
    }

    function Get_Tree($tid)
    {
        global $QF, $FOX;
        if (!is_numeric($tid))
            return false;

        $tid = (int) $tid;
        if (isset($this->ptrees[$tid]) || $this->_Load_Tree($tid))
            return $this->ptrees[$tid];

        return null;
    }

    function _Load_Tree($tid)
    {
        global $QF, $FOX;
        if (!is_numeric($tid))
            return false;

        $tid = (int) $tid;
        $cachename = QF_PSTTREE_CACHE_PREFIX.$tid;

        if ($tdata = $QF->Cache->Get($cachename))
        {
            $this->ptrees[$tid] = $tdata;
            return true;
        }
        elseif ($tinfo = $QF->DBase->Do_Select('pt_roots', '*', Array('root_id' => $tid)))
        {
            $pinfos = $QF->DBase->Do_Select_All('pt_posts', Array('post_id', 'parent', 'time', 'deleted'), Array('root_id' => $tid), 'ORDER BY `time` ASC' );
            $ptree = qf_2darray_tree($pinfos, 'post_id', 'parent', 0);

            $tinfo['ptree'] = $ptree;

            $this->ptrees[$tid] = $tinfo;
            $QF->Cache->Set($cachename, $tinfo);
            return true;
        }

        return false;
    }

    function _Parse_RootParams($params, $new_params)
    {
        static $my_params = Array('class', 'a_key', 'b_key1', 'b_key2', 'b_key3', 'caption', 'data');
        if (!is_array($params))
            return Array();

        $out_params = Array();
        foreach($my_params as $par_name)
        {
            if (isset($new_params[$par_name]))
                $out_params[$par_name] = $new_params[$par_name];
        }

        if (isset($out_params['data']))
            $out_params['hash'] = md5($out_params['data']);


        $r_level = (isset($new_params['r_level'])) ? $new_params['r_level'] : $params['r_level'];
        $w_level = (isset($new_params['w_level'])) ? $new_params['w_level'] : $params['w_level'];
        $r_level = 0;
    }
}

?>